function mainBrainbow(directory)
% Main of Neo Projection Fibers
% if nargin ==0
directory = 'C:/ERHAN/WORK/DATA/DIADEM/Neuromuscular Projection Fibers/';
% end
addpath(genpath([cd '/mfiles']))
beginn = 1;
if (beginn)
    
    
    params.dim.x = 1024;
    params.dim.y = 1024;
    
    [values, PairwiseOverlapIndicatorMatrix, RelativeCoordinatesXY]= trans;
    
    params.numOfImages = values(:,1);
    params.translations_xyz = [values(:,2:3) ones(length(values(:,2:3)),1)];
    params.zdist = 1;%3.40;
    seedxy =[377,8387,1;
        243,8388,1;
        273,8388,1;
        413,8386,1;
        324,8385,1;
        170,8390,1];
    
    for i=1
        
        seed = [seedxy(:,3) seedxy(:,2) seedxy(:,1)];
        
        params.tangVecprev = [1;-1;1];   %initial direction of pc
        params.kernelWeightFactor = .2; %power of the weight term in tracing step
        params.Factors.neig=2;  % weights of vectorial tracing
        params.Factors.vprev=1;
        params.Tracing.lenTang=1;    %tangent vec
        params.Tracing.lenVal=1;  %color
        params.branchFibStart = 4;
        params.Bif.varThr = false;
        params.Bif.remLowThr = .5;
        params.Bif.Rmin = 4;
        params.Bif.Rmax = 14;
        params.Bif.clusterSize = 3;
        params.Bif.ClusterDistThr = 5;
        params.Bif.centroidImtensityThr = .3;
        params.Bif.intensityThr = .05;
        params.remIntensityThr = .15;
        params.IntensityThr = .1;
        
        params.MS.sptSig = 3;    %to find bifurcations use a smaller spt. kernel
        params.MS.colSig = .5;    %to find bifurcations use a smaller spt. kernel
        params.varSig = true;
        params.varSigMax = 7;
        params.varSigMin = 2.5;
        params.varSigMinBound = 1.5;
        x=[17 27];
        y=[params.varSigMax params.varSigMin];
        a=(y(2)-y(1))/(x(2)-x(1));
        b=y(1)-a*x(1);
        params.varSigCoef = [a,b];
        
        params.smoothImages = true;
        
        params.forePerc = 100;
        params.filt = true;
    end
    params.seeds = seed;
    params.zdown = 4;
    params.xdown = 4;
    params.sptSig = 2.5;
    params.colSig = .5;
    f=[];
    
    % find the current stack ....
    
    tic
    %%
    for stackNum = 1:152
        
        params.directory = [directory];
        %         params.numOfImages(stackNum) = 64;
        
        % Load Images
        IM=zeros(params.numOfImages(stackNum),params.dim.y/params.xdown,params.dim.x/params.xdown);
        dim = size(IM);
        for i=1:dim(1)
            if params.numOfImages(stackNum)<101
                loadName = sprintf('%s%03d/%02d.tif',params.directory,stackNum,i-1);
            else
                loadName = sprintf('%s%03d/%03d.tif',params.directory,stackNum,i-1);
            end
            imtemp = im2double(imread(loadName));
            h = fspecial('gaussian',[9 9],9/6);
%             if params.smoothImages
%                 imtemp = imresize(imfilter(imtemp,h),1/params.xdown);
%             end
                imtemp = imresize(imtemp,1/params.xdown);
            IM(i,:,:) =imtemp;
        end
        IM2=zeros(params.numOfImages(stackNum)/params.zdown,params.dim.y/params.xdown,params.dim.x/params.xdown);
        dim = size(IM2);
        parfor i=1:dim(2)
            IM2(:,i,:) = imresize(squeeze(IM(:,i,:)),[dim(1),dim(3)]);
        end
        
        data = IM2;
        [Y X Z]= meshgrid(1:dim(2),1:dim(1),1:dim(3));
        params.zdist = 1;
        indVec = [round(params.zdist*X(:)),Y(:),Z(:)];
        dataVec = [indVec data(:)];
        foreIm = logical(data(:)>12*(max(data(:))/params.forePerc)); %intensity threshold
        imVec = dataVec(foreIm,:);
        p = imVec(:,1:3)-1;
        %             p = p + repmat((params.translations_xyz(stackNum,[3 2 1])...
        %                 ./[params.zdown params.xdown params.xdown]),length(imVec),1);
        c = imVec(:,4);
        
        f = [p c];
        %         clearvars -except f foreIm dim data params dataVec stackNum
        fori = f;
        
        %     save Data
        %
        f = fori;
        N = length(f);
        %         [Y X Z]= meshgrid(1:dim(2),1:dim(1),1:dim(3));
        %         f = [fshift f(:,4)];
        %
        %         dim = max(f(:,1:3));
        indforeIm = find(foreIm);%sub2ind(dim,f(:,1),f(:,2),f(:,3));
        IndI = zeros(1,length(foreIm));
        IndI(indforeIm) = 1:N;
        %         IndIm = zeros(1,prod(dim));
        %         IndImMask = zeros(1,prod(dim));
        %         IndIm(indforeIm)=f(:,4);
        %         IndImMask(indforeIm)=1;
        %         ForImageMask = reshape(IndImMask,dim(1),dim(2),dim(3));
        ForImage = foreIm;%reshape(IndIm,dim(1),dim(2),dim(3));
        
        %
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        % Create KNN graph
        ptrtree=BuildGLTree(f(:,1:3));
        k=min(250,size(f,1));  %500->R~5, 250->R~4
        
        [KNNG,distances]=KNNSearch(f(:,1:3),f(:,1:3),ptrtree,k);
        N = length(KNNG);
        %
        f(:,4) = f(:,4)/max(f(:,4));
        f_filt = f;
        
        indknn_ = 1:k;
        
        params.featDimP = 3;
        params.featDimC = 1;
        params.featDim = params.featDimC + params.featDimP;
        
        params.ani = 0;
        params.invCi = [];
        params.invCxi=[];
        params.knnNum = k;
        params.fullH = 0;   %0-> uses only Hpp, 1: full H
        
        % params.sptSigx = params.sptSig;
        % params.sptSigy = params.sptSig;
        % params.sptSigz = params.sptSig;
        params.scale = 1;
        params.normalUpdateThr = .5;
        Inext=zeros(params.featDimP,length(KNNG));
        
        
        % Calculate initial PC projections
        projPoints1 = zeros(params.featDimP,N);
        projPointsf1 = zeros(params.featDimP,N);
        projVecs1 = zeros(params.featDimP,params.featDimP,N);
        Covx1 = zeros(3,3,N);
        % matlabpool(4)
        parfor indexOfVoxel=1:N
            sptSig = params.sptSig;
            if ~mod(indexOfVoxel,1000)
                indexOfVoxel
            end
            indknn = KNNG(indexOfVoxel,1:k);
            f_i = f(indknn,:)';
            x = f_i(:,end);
            xg = round(x(1:3)./[params.zdist;1;1]);
            
            [pcUpdate_normal subSpace pctang SI vals] = pcProj(x,f_i,params,f_i(4,:).^1,sptSig);
            proj_normalD = pcUpdate_normal;%./[params.zdist;1;1];
            it = 1;
            ind_it=1;
            
            if any(abs(proj_normalD) >params.normalUpdateThr)
                continue;
            else
                %             while any(abs(pcUpdate_normal./[params.zdist;1;1])>.05) &  ind_it & it<=100
                while any(abs(pcUpdate_normal)>.05) &  ind_it & it<=100
                    [pcUpdate_normal subSpace pctang SI vals] = pcProj(x,f_i,params,f_i(4,:).^1,sptSig);
                    proj_normalD = proj_normalD + pcUpdate_normal./[params.zdist;1;1];
                    x(1:params.featDimP) = x(1:params.featDimP) + pcUpdate_normal;
                    %                 hold on, plot3(x(3),x(2),x(1),'g.')
                    xg = round(x(1:3)./[params.zdist;1;1]);
                    xg = max([1;1;1],xg);
                    xg = min(dim(:),xg);
                    ind_it = IndI(sub2ind(dim(1:3),xg(1,:),xg(2,:),xg(3,:)));
                    if ~ind_it %| any(abs(pcUpdate_normal./[params.zdist;1;1]) >params.normalUpdateThr)
                        continue;
                    end
                    x(params.featDimP+1:end) = f(ind_it,(params.featDimP+1:end));
                    
                    indknn = KNNG(ind_it,1:k);
                    f_i = f(indknn,:)';
                    it = it+1;
                end
                
                if it>100 | ~ind_it
                    continue;
                end
                
                projPoints1(:,indexOfVoxel) = xg;
                projPointsf1(:,indexOfVoxel) = x(1:params.featDimP);
                projVecs1(:,:,indexOfVoxel) = [pctang(:) subSpace];
                temp = inv(SI);
                Covx1(:,:,indexOfVoxel) = sign(temp(1))*temp;
            end
        end
        
        
        % save vs7_PC_knn300_.mat
        %
        %         Im=ForImage/max(ForImage(:));
        %         clear Im2;
        %         Im2 = zeros([size(Im) 3]);
        %         Im2(:,:,:,1)=Im;
        %         Im2(:,:,:,2)=Im;
        %         Im2(:,:,:,3)=Im;
        
        %
        params.varSig = 0;
        if 1
            if ~params.varSig
                indPC = find(any(projPointsf1));
                projPointsSet = projPointsf1(:,indPC);
%                 figure,
%                 imtemp = squeeze(IM2(15,:,:,:));
%                 imshow(imtemp,[]),hold on,
%                 plot3(projPointsSet(3,:),projPointsSet(2,:),projPointsSet(1,:),'g.')
%                 title([num2str(params.sptSig),';',num2str(params.colSig),';',num2str(params.normalUpdateThr)])
                projPoints = projPoints1;
                projPointsf = projPointsf1;
                projVecs = projVecs1;
                Covx = Covx1;
            else
                indPC = find(any(projPointsf2));
                projPointsSet = projPointsf2(:,indPC);
                %                 figure,
                %                 imshow(squeeze(Im2(14,:,:,:)),[]),hold on,
                %                 plot3(projPointsSet(3,:),projPointsSet(2,:),projPointsSet(1,:),'g.')
                %                 title([num2str(params.colSig),';',num2str(params.sptSig),';',num2str(params.normalUpdateThr)])
                projPoints = projPoints2;
                projPointsf = projPointsf2;
                projVecs = projVecs2;
                Covx = Covx2;
            end
        end
        
        figure(2), for i=1:dim(1);imtemp = squeeze(IM2(i,:,:,:));imshow(imtemp,[]);hold on, plot3(projPointsSet(3,:),projPointsSet(2,:),projPointsSet(1,:),'g.');drawnow;end
        
%         indVals = f(find(any(round(projPointsf(:,:)),1)),4)>.05;
        ProjectionsPoints{stackNum} =  projPointsf;
        ProjectionsIndecies{stackNum} = projPoints;
        ProjectionsVecs{stackNum} = projVecs;
        %         ProjectionsIndecies{stackNum} = projPoints;
        
        
        %
        %
        %         hold on, plot3(projPointsSet(3,indVals),projPointsSet(2,indVals),projPointsSet(1,indVals),'r.')
        %         figure
        %         imshow(imtemp,[]),hold on,
        %         plot3(projPointsSet(3,indVals),projPointsSet(2,indVals),projPointsSet(1,indVals),'r.')
        toc
        [stackNum 152]
        if ~mod(stackNum,10)
            stop=1;
        end
    end
end

%%
PT=[];
t = params.translations_xyz(:,[3 2 1]);
t = t./repmat([1 9 9],length(t),1);
for i=1:stackNum
  Y=ProjectionsPoints{i};
  Y_ = Y(:,any(Y>0));
  Y_ = Y_ + repmat(t(i,:)',1,length(Y_));
  PT=[PT Y_];
end
%%


% 
% 
% 
% %%  Trace a fiber
% params.visual = 0;
% numOfFiber=1;
% 
% PC=[];
% PCAll = [];
% params.fig=31;
% params.visual = 0;
% 
% bifCheck = 0;
% seed = params.seeds;% -repmat(minBound,length(params.seeds),1);
% 
% numOfTrace = 1;
% tangVecprev = params.tangVecprev;
% cfori = ceil(fori(:,1:params.featDimP));
% 
% params.seed = ceil(seed(numOfTrace,:)./[params.zdown params.xdown params.xdown]);
% indexOfSeed=find(all(cfori==repmat(params.seed(1:params.featDimP),length(f),1),2));
% params.initSeed = indexOfSeed;
% if isempty(indexOfSeed)
%     x = fori(:,1:params.featDimP);
%     y=params.seed;
%     [pD indexOfSeed]= pdist2(x,y,'euclidean','Smallest',1);
% end
% 
% indknn = KNNG(indexOfSeed,1:params.knnNum);
% f_i = f(indknn,:)';
% w_i = f(indknn,4);    w_i = (w_i/sum(w_i)).^.5;
% 
% wf_i = (f_i(1:params.featDimP,:)-repmat(f_i(1:params.featDimP,end),1,params.knnNum)).*repmat(w_i',params.featDimP,1);
% wcov = cov(wf_i');
% [a b] = eig(wcov);
% [~,indb] = sort(diag(b),'descend');
% a=a(:,indb);
% 
% tangVecprev = a(:,1);
% tangVecprev = [0;0;1];
% initSeed = indexOfSeed;
% params.dim.z = dim(1);
% params.remCheck = 0;
% params.permute=0;
% 
% params.filt = 0;
% params.f_filt = f;
% 
% params.dim.x = dim(3);    params.dim.y = dim(2);    params.dim.z = dim(1);
% params.varSptSig = 0;
% params.Tracing.lenTang =5;
% params.Bif.centroidImtensityThr = 0;
% params.minBound = minBound;
% params.IntensityThr = .0001;
% [PC1 numOfFiber1 PCAll1 projPointsRem1 projPointsfRem1] = branchIt(f,indexOfSeed,tangVecprev,Im2,KNNG,IndI,PC,numOfFiber,initSeed,projPoints,projPointsf,projVecs,PCAll,params);
% [PCb,numOfFiberb,PCAllb,projPointsRemb,projPointsfRemb] = deal(PC1,numOfFiber1,PCAll1,projPointsRem1,projPointsfRem1);
% 
% %%
% for i=1:length(seed)
%     params.seed = ceil(seed(i,:)./[params.zdown params.xdown params.xdown]);
%     indexOfSeed=find(all(cfori==repmat(params.seed(1:params.featDimP),length(f),1),2),1);
%     if isempty(indexOfSeed)
%         x = fori(:,1:params.featDimP);
%         y=params.seed;
%         [pD indexOfSeed]= pdist2(x,y,'euclidean','Smallest',1);
%     end
%     
%     indRoots(i) = indexOfSeed;
% end
% 
% params.indRoots = indRoots;
% %%
% for numOfTrace=2:length(seed)
%     if numOfTrace == 15
%         stop=1;
%     end
%     params.seed = ceil(seed(numOfTrace,:)./[params.zdown params.xdown params.xdown]);
%     indexOfSeed=find(all(cfori==repmat(params.seed(1:params.featDimP),length(f),1),2),1);
%     if isempty(indexOfSeed)
%         x = fori(:,1:params.featDimP);
%         y=params.seed;
%         [pD indexOfSeed]= pdist2(x,y,'euclidean','Smallest',1);
%     end
%     params.initSeed = indexOfSeed;
%     
%     indknn = KNNG(indexOfSeed(1),1:params.knnNum);
%     f_i = f(indknn,:)';
%     w_i = f(indknn,4);    w_i = (w_i/sum(w_i)).^.5;
%     
%     wf_i = (f_i(1:params.featDimP,:)-repmat(f_i(1:params.featDimP,end),1,params.knnNum)).*repmat(w_i',params.featDimP,1);
%     wcov = cov(wf_i');
%     [a b] = eig(wcov);
%     [~,indb] = sort(diag(b),'descend');
%     a=a(:,indb);
%     
%     tangVecprev = a(:,1);
%     [PC1,numOfFiber1,PCAll1,projPointsRem1,projPointsfRem1] = deal(PCb,numOfFiberb,PCAllb,projPointsRemb,projPointsfRemb);
%     numOfFiber1 = numOfFiber1+1;
%     
%     [PC1 numOfFiber1 PCAll1 projPointsRem1 projPointsfRem1] = branchIt(f,indexOfSeed,tangVecprev,Im2,KNNG,IndI,PC1,numOfFiber1,initSeed,projPointsRem1,projPointsfRem1,projVecs1,PCAll1,params);
%     [PCb,numOfFiberb,PCAllb,projPointsRemb,projPointsfRemb] = deal(PC1,numOfFiber1,PCAll1,projPointsRem1,projPointsfRem1);
%     
%     [PC1,numOfFiber1,PCAll1,projPointsRem1,projPointsfRem1] = deal(PCb,numOfFiberb,PCAllb,projPointsRemb,projPointsfRemb);
%     
%     numOfFiber1 = numOfFiber1+1;
%     [PC1 numOfFiber1 PCAll1 projPointsRem1 projPointsfRem1] = branchIt(f,indexOfSeed,-tangVecprev,Im2,KNNG,IndI,PC1,numOfFiber1,initSeed,projPointsRem1,projPointsfRem1,projVecs1,PCAll1,params);
%     [PCb,numOfFiberb,PCAllb,projPointsRemb,projPointsfRemb] = deal(PC1,numOfFiber1,PCAll1,projPointsRem1,projPointsfRem1);
%     
% end
% 
% for ty=1
%     %%
%     [PC1,numOfFiber1,PCAll1,projPointsRem1,projPointsfRem1] = deal(PCb,numOfFiberb,PCAllb,projPointsRemb,projPointsfRemb);
%     % check any remaning points
%     params.remCheck = 1;
%     endTrace = 0;
%     while ~endTrace
%         [PC1 numOfFiber1 PCAll1 projPointsRem1 projPointsfRem1 endTrace] = checkRem(f,Im2,KNNG,IndI,PC1,numOfFiber1,[],projPointsRem1,projPointsfRem1,projVecs,PCAll1,params);
%     end
%     %%
%     % folder = 'C:/ERHAN/WORK/DATA/DIADEM/Neocortical Layer 6 Axons/Qualifier/';
%     % % PC1=PC
%     % [SWC1 S1 B1 wS1] = createConMatrix(PC1,f,params);
%     % SWC1(:,5) = SWC1(:,5)*params.zdown;
%     % SWC1(:,3:5) = SWC1(:,3:5) + repmat(minBound([3 2 1]),length(SWC1),1);
%     %
%     % file_1 = fopen([folder,'Qual_OF_Test_',num2str(numOfTrace),'vs_S1.swc'],'w');
%     % fprintf(file_1,'# Neurolucida to SWC conversion from L-Measure.\n');
%     % fprintf(file_1,'%d %d %4.3f %4.3f %4.3f %d %d\n',SWC1');
%     % fclose(file_1);
%     % isconnected(S1)
%     %%
%     PC=PC1;
%     [SWC2 S2] = createConMatrix2(PC,cfori,params);
%     SWC2{1}(:,[3 4 5]) = SWC2{1}(:,[3 4 5]).*repmat([ params.xdown params.xdown params.zdown],length(SWC2{1}),1);
%     %%
%     for i=1:length(SWC2)
%         SWC_ = SWC2{i};
%         numOfTrace=1;
%         file_1 = fopen([folder,'Qual_OF_Test_',num2str(numOfTrace),'vs_S1.swc'],'w');
%         fprintf(file_1,'# Neurolucida to SWC conversion from L-Measure.\n');
%         fprintf(file_1,'%d %d %4.3f %4.3f %4.3f %d %d\n',SWC_');
%         fclose(file_1);
%         isconnected(S1)
%     end
% end
% 
