function [PC numOfFiber PCAll projPoints projPointsf endTrace] = checkRem(f,Im2,KNNG,IndI,PC,numOfFiber,initSeed,projPoints,projPointsf,projVecs,PCAll,params)

indPC = find(any(projPointsf));
Y = f(PCAll,1:params.featDimP);

if params.varSig
Rtrace = params.Bif.remLowThr*params.varSptSig(indPC);
else
    Rtrace = 0;
end
[centers eliminateProj tangVecprev3] = bifurcationDetection(projPointsf,Y,indPC,params, Rtrace,projVecs);

% X = PC{numOfFiber}.Trajectory_fSub';
pD = (pdist2(Y,centers'));
[~, indminTang]= min(pD,[],1);
tangVecprev2 = Y(indminTang,:)'-centers;

endTrace = 0;
if isempty(centers)
    % Finish the tracing
    endTrace = 1;
else
    X = projPointsf(:,indPC)';
    pD = (pdist2(X,centers'));
    [~, indmin]= min(pD,[],1);
    bifCandidate = IndI(sub2ind([params.dim.z params.dim.y params.dim.x],round(X(indmin,1)),...
        round(X(indmin,2)),round(X(indmin,3))));
 %%   
    bifCheck = 1;
    bifurFlagL=[];
    bifurFlagR=[];
    
    for i = 1:length(bifCandidate)
        indexOfSeed = bifCandidate(i);
        %     tangVecprev = projVecs(:,1,indexOfSeed);
        tangVecprev = tangVecprev2(:,i); % for cerebellar
%         tangVecprev = tangVecprev3(:,i); % olfactory

        [~, bifurFlagR(i), bifurTraceR{i}] = traceFiberRem(f,indexOfSeed,-tangVecprev,Im2,KNNG,IndI,PC,numOfFiber,bifCheck,PCAll,initSeed,params);
        if isempty(bifurTraceR{i});bifurFlagR(i)=0;end
        [~, bifurFlagL(i), bifurTraceL{i}] = traceFiberRem(f,indexOfSeed,tangVecprev,Im2,KNNG,IndI,PC,numOfFiber,bifCheck,PCAll,initSeed,params);
         if isempty(bifurTraceL{i});bifurFlagL(i)=0;end
       
        if bifurFlagL(i) & bifurFlagR(i)
            if(bifurTraceL{i}.valmin<bifurTraceR{i}.valmin)
                bifurFlagR(i)=0;
                bifurTraceR{i} =[];
            else
                bifurFlagL(i)=0;
                bifurTraceL{i} =[];
            end
        end
    end
    bifurFlag = bifurFlagL | bifurFlagR;
%%    
    if ~sum(bifurFlag)
        PCAll = union(PCAll,PC{numOfFiber}.Trajectory);
        endTrace=1;
        return;
    end
    PCAll = union(PCAll,PC{numOfFiber}.Trajectory);
    projPoints(:,eliminateProj)=0;
    projPointsf(:,eliminateProj)=0;
    
    bifCandidate(bifurFlag)
    
    fibStart = params.branchFibStart;
    branchcount=1;
    for i=find(bifurFlagR)
        indBif = fliplr(bifurTraceR{i}.traj);
        fFib = fliplr(bifurTraceR{i}.fSub);
        indU = min(fibStart+1,size(fFib,2));
        if indU<2
            PCAll = union(PCAll,indBif);
            continue;
        end
        tangVecprev = fFib(:,indU)-fFib(:,indU-1);
        indexOfSeed = indBif(indU-1);
        initSeed = bifurTraceR{i}.parentNode;
        numOfFiber = numOfFiber + branchcount;
        [PC numOfFiber PCAll projPoints projPointsf] = branchIt(f,indexOfSeed,tangVecprev,Im2,KNNG,IndI,PC,numOfFiber,initSeed,projPoints,projPointsf,projVecs,PCAll,params);
    end
    for i=find(bifurFlagL)
        indBif = fliplr(bifurTraceL{i}.traj);
        fFib = fliplr(bifurTraceL{i}.fSub);
        indU = min(fibStart+1,size(fFib,2));
        if indU<2
            PCAll = union(PCAll,indBif);
            continue;
        end
        tangVecprev = fFib(:,indU)-fFib(:,indU-1);
        indexOfSeed = indBif(indU-1);
        initSeed = bifurTraceL{i}.parentNode;
        numOfFiber = numOfFiber + branchcount;
        [PC numOfFiber PCAll projPoints projPointsf] = branchIt(f,indexOfSeed,tangVecprev,Im2,KNNG,IndI,PC,numOfFiber,initSeed,projPoints,projPointsf,projVecs,PCAll,params);
    end
end