function [ar_mode,I,S,D,W] = medoidshiftIterative(D,lambda,sigma)
% [ar_mode,I,S,D,W] = medoidshift_iterative(D,lambda,sigma)
% D:      Distance Matrix
% sigma:  Bandwidth parameter
% lambda: Votes for a point
% if v is an identity matrix replace with NaN

W = exp(-0.5*D/sigma);

if(~isnan(lambda))
    S = D*lambda*W;
else
    S = D*W;
end

[y,I] = min(S,[],1);
ar_mode = classify(I);
function [ar_mode] = classify(I)
% Tree Traversal

ar_path = zeros(size(I));
ar_mode = zeros(size(I));

%for each point
for i=1:size(I,2)   
    [ar_mode(i),ar_path] = findMode(I(i),I,ar_path);
    ar_path(i) = 1;
end

% Recursion
function [mode, ar_path] = findMode(curr,I,ar_path)

if(curr == I(curr))
    mode = curr;
else
    [mode, ar_path] = findMode(I(curr),I,ar_path);
end
ar_path(curr) = 1;