% function visualizeClustering(ar_mode,x)
% % Function to visualize 2D clustering
% % ar_mode: Pointer array to mode
% % x:       Dataset
% 
% [a,b,ar] = unique(ar_mode);
% fig=1;
% if(length(a)<64)
%     figure(fig), hold on,
%     c = lines;
%     c(3,:)=[];
%        markers = ['*','+','x','.','s','o','^','v','o','s','x','.','+','*','^','v','o','s','x','.','+','*','^','v','o','s','x','.','+','*','^','v','o','s','x','.','+','*','^','v'];
% %     markers = ['............................................................................................']; % Don't ask...
%     
%     for i = 1:length(x)
%         if(size(x,1)==2)
%             plot(x(1,i), x(2,i),markers(ar(i)),'Color',c(ar(i),:));
%         else
%             plot3(x(3,i), x(2,i),x(1,i),markers(ar(i)),'Color',c(ar(i),:));
%         end
%     end
% else
%     figure(1), hold on,
%     
%     if(size(x,1)==2)
%         plot(x(1,:), x(2,:),'r.');
%     else
%         plot3(x(3,:), x(2,:),x(1,:),'r.');
%     end
% end
% 
% if(size(x,1)==2)
%     plot(x(1,a),x(2,a),'k.','MarkerSize',20)
% else
%     plot3(x(3,a),x(2,a),x(1,a),'k.','MarkerSize',20)
% end
% 
% axis equal, box on, grid on;
function visualizeClustering(ar_mode,x)
% Function to visualize 2D clustering
% ar_mode: Pointer array to mode
% x:       Dataset

[a,b,ar] = unique(ar_mode);
fig=66;
if(length(a)<64)
    figure(fig),
    hold on,
    c = lines;
    c(3,:)=[];
       markers = ['*','+','x','.','s','o','^','v','o','s','x','.','+','*','^','v','o','s','x','.','+','*','^','v','o','s','x','.','+','*','^','v','o','s','x','.','+','*','^','v'];
       markers = repmat(markers,1,2);
%     markers = ['............................................................................................']; % Don't ask...
    
    for i = 1:length(x)
        if(size(x,1)==2)
            plot(x(2,i), x(1,i),markers(ar(i)),'Color',c(ar(i),:));
        else
            plot3(x(3,i), x(2,i),x(1,i),markers(ar(i)),'Color',c(ar(i),:));
        end
    end
else
    figure(fig),
    hold on,
    
    if(size(x,1)==2)
        plot(x(2,:), x(1,:),'r.');
    else
        plot3(x(3,:), x(2,:),x(1,:),'r.');
    end
end

% if(size(x,1)==2)
%     plot(x(2,a),x(1,a),'y.','MarkerSize',20)
% else
%     plot3(x(3,a),x(2,a),x(1,a),'k.','MarkerSize',20)
% end

axis equal, box on, grid on;