function [SWC S B wS] = createConMatrix(PC,f,params)

C = [];
Cf=[];
for i=1:length(PC)
    child = PC{i}.Trajectory(2:end)';
    parent = PC{i}.Trajectory(1:end-1)';
    if length(PC{i}.Trajectory) ~=size(PC{i}.Trajectory_fSub,2)
        i
    end
    C = [C;[child parent]];
    Cf = [Cf;PC{i}.Trajectory_fSub(:,2:end)'];
end
C_=zeros(length(C)+1,2);
Cf_=zeros(length(C)+1,3);
C_(2:end,:)=C;
Cf_(2:end,:)=Cf;
C_(1,:) = PC{1}.Trajectory(1)*ones(1,2);
Cf_(1,:) = PC{1}.Trajectory_fSub(:,1);
C = C_;
Cf=Cf_;
%
clc
clear wS B
X = C(2:end,:);
Xf = Cf(2:end,:);

[B1 I1 J1] = unique(X); % B = A(I) and A = B(J) (or B = A(I,:) and A = B(J,:)).
I = 1:length(B1);
% B=[B1 I'];
B=zeros(length(X),2);
for i=1:length(X)
    a = find(X(i,1)==B1);
    b = find(X(i,2)==B1);
    fpdist=norm(f(X(i,1),1:3)-f(X(i,2),1:3));
    fcdist=abs(f(X(i,1),4)-f(X(i,2),4));
    fcs=(f(X(i,1),4)+f(X(i,2),4))/2;
    
    wS(i) = exp(-(fpdist+fcdist))*fcs;
%     wS(i) = sum([f(X(i,1),4) f(X(i,2),4)],2)/2;
    B(i,:)=[a,b];
end
nS = max(B(:));
S = sparse(B(:,1),B(:,2),wS,nS,nS);
S = S+S';

% [D,pred,cl] = graphtraverse(S,B(1,2));
[~,pred] = graphminspantree(S,B(1,2),'METHOD','Kruskal');
[b t j] = unique([B(1,2);B(:,1)]);
Xperm = C(t,:); %permute X
Xfperm = Cf(t,:);

SWC = zeros(length(Xperm),7);
for i=1:length(Xperm)
    SWC(i,[1 2]) = [i 2];
    SWC(i,3:5) = Xfperm(i,[3 2 1]);
    SWC(i,6) = 1;
    SWC(i,7) = pred(i);
end

SWC(:,5) = params.zdist*SWC(:,5);
rootN=find(SWC(:,7)==0);
SWC(rootN,7) = -1;
% temp = SWC(1,:);
% SWC(1,:)=SWC(rootN,:);
% SWC(rootN,:)=temp;

end