Description of files:

There are 5 folders, each having algorithm and results. We used Matlab 64bit R2010a. We added mex files for certain functions, and they must be compiled prior to execution of provided Matlab scripts. The m-file "main_" in the name will execute all needed code to generate the results assuming data directories are provided properly. In Olfactory and Hippocampal datasets number must be specified in addition to the directory parameter. In each directory SWC files are included showing results. An exception is Brainbow in which we include Matlab files that generate the provided "fig" file. This figure shows samples from the centerlines from the fibers, but due to lack of time we could not complete the SWC formatted tree generation task. 

Our SWC files do not necessarily contain distinct trees for each seed provided. For example we submitted 14 trees for Neocortical Layer 6 axons where 20 SWC files are requested. After the algorithm found the solutions our visual inspection to identify the source of discrepancy convinced us that the algorithm results are accurate. When the algorithm identifies the connectivity solution for the first seed it might pass nearby another seed such that when the other seed is used to initialize  the algorithm it quickly merges with the fibers that have been traced. 

Due to relative low resolution at places where branches have formed geometries that passes very close to each other, images occasionally show loops. Principal curve tracing identifies these loops, so our algorithm employs minimum spanning trees to prune the graphs with loops into dendritic trees. It is possible that the low resolution might be the source of merging of solutions of two seeds.

Since our algorithm operates in 3D, the low peak resolution of the Hippocam data in the z direction was a detrimental factor. The local maximum of a function in its cross section can approximate the ridge location and we used this property of principal curves to tackle this dataset in 2D using maximum intensity projections.




Description of algorithm:

The algorithm is based on the concept of constructing a function whose ridge traverses the centerline of the axons. Kernel machine techniques are used to construct these functions non-parametrically. A fast principal curve tracing algorithm that we developed is used to trace the ridges constructed as described above. Due to lack of time the functions were mainly based on isotropic fixed width kernels while theory tells better performance could be obtained using anisotropic variable width kernels. However this will increase computational time. 

Although the tracing component of the algorithm is quite efficient, in our workstation it can handle up to 500K data samples. When preprocessed combined Brainbow stacks yielded 3M in samples which would require us rewrite the code to handle stacks individually and coordinate across stack boundaries. Unfortunately, we did not have the time to do this and generate SWC format results. 

The algorithm is based on describing the 3D geometric structure as well as color/edge/texture/spatial/type image features using non-parametric kernel density estimates. The tracing is achieved by tracing the ridge of the image feature density as a function of 3D position in subpixel accuracy. The image feature is used will depend on the particular dataset. Algorithm operates on full stack(s) in 3D and not in 2D image slices. 



Last notes:
1) We learned that this challenge requires more than 6 weeks. 
2) In dataset Neo6, we confirmed visually and with the HMMI committee that 'z' coordinate of NC28 should be 43 rather than 47. We were told that the included slice 47 is incorrect and it should have contained the seed node. Consequently we ignored NC28 and we hope this does not negatively affect the score for this problem.
3) We made no attempt to overfit the parameters or manipulate the algorithm outcome in a manner that will help to improve the score artificially. 



References:

1 - E.Bas and D.Erdogmus, "Principal curve tracing", ESANN 2010.
2 - U.Ozertem, " Locally Defined Principal Curves and Surfaces", Ph.D. Dissertation, OHSU, 2008.

 